/******************************************************************************/
/*!
 * \file timlUtilRandNormalRNG.c
 */
/* Copyright (C) 2015 Texas Instruments Incorporated - http://www.ti.com/
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *    Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 *    Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the
 *    distribution.
 *
 *    Neither the name of Texas Instruments Incorporated nor the names of
 *    its contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 ******************************************************************************/


/*******************************************************************************
 *
 * INCLUDES
 *
 ******************************************************************************/

#include "../api/timl.h"
#ifdef TIML_ALT
#include "../../alt/timlAlt.h"
#endif

inline float uniformRNG()
{
   return (rand() + 1.0) / (RAND_MAX + 1.0);
}

/*******************************************************************************/
/*!
 * \ingroup util
 * \brief      Generate a Gaussian random number
 * \param[out] x    Guassian random vector
 * \param[in]  dim  Vector dimension
 * \param[in]  mean Mean
 * \param[in]  std  Standard deviation
 * \return     Error code
 */
/*******************************************************************************/

int timlUtilRandNormalRNG(float *x, int dim, float mean, float std)
{
#ifdef TIML_CPU
   int i;
   float y;
   for (i = 0; i < dim; i++) {
      y = sqrt(-2*log(uniformRNG()))*cos(2*TIML_UTIL_PI*uniformRNG());
      x[i] = std*y + mean;
   }

   return 0;
#elif defined TIML_ALT
   return timlUtilNormalRNGAlt(x, dim, mean, std);
#endif

}

